#ifndef __SIGNAL_H__
#define __SIGNAL_H__
#ifdef __cplusplus
extern "C" {
#endif
/**************************************************************************
 *									  *
 * 		 Copyright (C) 1989, Silicon Graphics, Inc.		  *
 *									  *
 *  These coded instructions, statements, and computer programs  contain  *
 *  unpublished  proprietary  information of Silicon Graphics, Inc., and  *
 *  are protected by Federal copyright law.  They  may  not be disclosed  *
 *  to  third  parties  or copied or duplicated in any form, in whole or  *
 *  in part, without the prior written consent of Silicon Graphics, Inc.  *
 *									  *
 **************************************************************************/

/* #ident "$Revision: 1.17 $" */

#include <sys/signal.h>

#if defined(_LANGUAGE_C) || defined(_LANGUAGE_C_PLUS_PLUS)
extern int	raise(int);
#endif /* C or C++ */

#if (defined(__EXTENSIONS__) || defined(_POSIX_SOURCE))
/*
 * The signal-masking routine sgi_altersigs() (NOT a part of the POSIX
 * standard) contains an action parameter; the routine can either add
 * or delete a set of signals.
 */
#define ADDSIGS		1
#define DELSIGS		2

/*
 * The following macro returns true if any of the signals in the sigset_t
 * pointed to by "setptr" are set.
 */
#define sgi_siganyset(setptr)	(sgi_sigffset(setptr,0) != 0)

#if defined(_LANGUAGE_C) || defined(_LANGUAGE_C_PLUS_PLUS)
extern int	sigaddset(sigset_t *,int);
extern int	sigdelset(sigset_t *,int);
extern int	sigemptyset(sigset_t *);
extern int	sigfillset(sigset_t *);
extern int	sigismember(sigset_t *,int);
extern int	sgi_altersigs(int,sigset_t *,int[]);
extern int	sgi_sigffset(sigset_t *,int);
extern int	sgi_dumpset(sigset_t *);

extern int	sigaction(int, struct sigaction *, struct sigaction *);
extern int	sigprocmask(int, sigset_t *, sigset_t *);
extern int	sigpending(sigset_t *);
extern int	sigsuspend(sigset_t *);

#if !defined(_POSIX_SOURCE)
#if defined(_LANGUAGE_C_PLUS_PLUS)
extern void	(*sigset(int, void (*) (int, ...)))(int, ...);
#else
extern void	(*sigset(int, void (*) ()))();
#endif
extern int	sigaltstack(stack_t *, stack_t *);
extern int	psignal(unsigned, char *);
#endif /* _POSIX_SOURCE */

#endif /* C or C++ */
#endif /* __EXTENSIONS__ || _POSIX_SOURCE */

#ifdef __cplusplus
}
#endif
#endif /* !__SIGNAL_H__ */
