/*	Copyright (c) 1984 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ifndef _SYS_FS_DBFCNTL_
#define _SYS_FS_DBFCNTL_

#pragma once

/*#ident	"@(#)kern-port:sys/fs/prfcntl.h	10.2"*/
#ident	"$Revision: 3.11 $"
/*	dbfcntl.h - fcntls for /debug */

#define DFC		('d'<<8)

#define DFCGETPR	(DFC|101)	/* read struct proc */
#define DFCOPENT	(DFC|102)	/* open text file for reading */
#define DFCEXCLU	(DFC|103)	/* mark text for exclusive use */

#define DFCSTOP		(DFC|104)	/* send STOP signal and... */
#define DFCWSTOP	(DFC|105)	/* wait for process to STOP */
#define DFCRUN		(DFC|106)		/* make process runnable */

#define DFCSMASK	(DFC|107)	/* set signal trace bit mask */
#define DFCCSIG		(DFC|108)	/* clear least significant signal */
#define DFCKILL		(DFC|109)	/* send signal */

#define DFCSEXEC	(DFC|110)	/* stop on exec */
#define DFCREXEC	(DFC|111)	/* run on exec */

#define DFCGMASK	(DFC|112)	/* get signal trace bit mask */

#define	DFCGETREGS	(DFC|113)	/* get registers */
#define	DFCPUTREGS	(DFC|114)	/* put registers */
#define	DFCSENTRYMASK	(DFC|115)	/* set system call entry trace mask */
#define	DFCGENTRYMASK	(DFC|116)	/* get system call entry trace mask */
#define	DFCSEXITMASK	(DFC|117)	/* set system call exit trace mask */
#define	DFCGEXITMASK	(DFC|118)	/* get system call exit trace mask */
#define	DFCABORT	(DFC|119)	/* abort system call in progress */
#define DFCGETPRINFO	(DFC|120)	/* read info from struct proc */
#define DFCSSTEP	(DFC|121)	/* single step */
#define DFCGETU		(DFC|122)	/* get user area */

/*
 * Argument codes for DFCRUN
 */
#define	CLEARNOSIG	-2		/* do not clear any signal */
#define	CLEARCURSIG	-1		/* clear current signal */
#define	CLEARALLSIG	 0		/* clear all signals */

					/*
					 * in addition, a value from 1-NSIG
					 * means to clear all pending signals
					 * and continue with given signal
					 */

/*
 * Argument for DFCGETPRINFO
 */
struct procinfo {
	char	pi_stat;		/* Status of process */
	ushort	pi_ppid;		/* Process id of parent */
	caddr_t	pi_wchan;		/* Wait address for sleeping process */
	ushort	pi_whystop;		/* Reason for process stop */
	ushort	pi_whatstop;		/* Accompanying info */
};

#ifdef _KERNEL
#define KPRIFORK 0x01		/* inherit on fork */
#endif

#endif
