/**************************************************************************
 *									  *
 * 		 Copyright (C) 1989, Silicon Graphics, Inc.		  *
 *									  *
 *  These coded instructions, statements, and computer programs  contain  *
 *  unpublished  proprietary  information of Silicon Graphics, Inc., and  *
 *  are protected by Federal copyright law.  They  may  not be disclosed  *
 *  to  third  parties  or copied or duplicated in any form, in whole or  *
 *  in part, without the prior written consent of Silicon Graphics, Inc.  *
 *									  *
 **************************************************************************/
/*	Copyright (c) 1984 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ifndef __GETPAGES_H__
#define __GETPAGES_H__

#ident	"$Revision: 3.11 $"

#include "sys/region.h"

/*	The following list is used to keep track of regions locked
 *	by getpages.
 */
typedef struct {
	reg_t	*gpr_rgptr;	/* Pointer to the region.	*/
	int	gpr_count;	/* Number of pages from this	*/
				/* region in spglist and 	*/
				/* fpglist.			*/
} gprgl_t;


/*	The following structure is used to maintain a list of
 *	pages to be stolen by getpages.
 */
typedef struct {
	pde_t	*gp_ptptr;	/* Ptr to page table entry.	*/
	gprgl_t	*gp_rlptr;	/* Ptr to region list entry.	*/
} pglst_t;

#define MAXPGLST	100	/* max size for page lists */

extern sema_t	vhandsema;	/* wakeup semaphore for vhand */
extern int rsskicklim;
extern int rsswaitcnt;
extern lock_t vhandwaitlock;
extern sema_t rsswaitsema;

extern int tossmpages(struct region *, union pde *, int, int, int *);
extern void getpages(struct region *, int (*)(struct region *, union pde *, int, int, int *), int, struct proc *);
extern void swapdone(struct buf *);

/*	Flags for getpages et al	*/

#define GTPGS_HARD	0x01	/* toss all pages in region */
#define GTPGS_TOSS	0x02	/* flush and free pages */
#define GTPGS_SYNC	0x04	/* flush pages */
#define GTPGS_INVAL	0x08	/* invalidate all buffers */
#define GTPGS_FORCE	0x10	/* force a stealing run */
#define GTPGS_NOWRITE	0x40	/* just steal, don't write page */
#define GTPGS_NOMFILE	0x80	/* do NOT do DBD_MFILE */

#define GTPGS_MOSTRECENT 7	/* most recently accessed page */

/*
 * This structure is used to build the binary tree which sorts the processes
 * in the system in a fixed order for the paging daemon to scan.
 */
typedef struct prilist_s {
	struct proc 		*pp;
	short			pid;
	unchar			pri;
	struct prilist_s	*parent;
	struct prilist_s	*left;
	struct prilist_s	*right;
} prilist_t;

#endif /* __GETPAGES_H__ */
