/**************************************************************************
 *									  *
 * 		 Copyright (C) 1986, Silicon Graphics, Inc.		  *
 *									  *
 *  These coded instructions, statements, and computer programs  contain  *
 *  unpublished  proprietary  information of Silicon Graphics, Inc., and  *
 *  are protected by Federal copyright law.  They  may  not be disclosed  *
 *  to  third  parties  or copied or duplicated in any form, in whole or  *
 *  in part, without the prior written consent of Silicon Graphics, Inc.  *
 *									  *
 **************************************************************************/

#ident "$Revision: 1.4 $"

/**************************************************************************
 *
 *	gseio.h
 *
 *	IO interface to the gse device driver (gse.c) running on a
 *	Silicon Graphics workstation
 *
 *	REVISIONS:
 *
 *	 6-02-88	HRG	Added Copyright
 *	 4-15-88	MEL	Added GIO_SETIV.
 *
 ***************************************************************************/

/*
 * ioctl cmds
 */
#define GIO		('g'<<8)
#define GIO_INIT	(GIO|1)		/* reset controller */
#define GIO_WAIT	(GIO|2)		/* wait for interrupt */
#define GIO_WRITE	(GIO|3)		/* write to controller */
#define GIO_READ	(GIO|4)		/* read from controller */
#define GIO_SIGNAL	(GIO|5)		/* mark signal processing */
#define GIO_SETIV	(GIO|6)		/* set interrupt vector */
/*
 * ioctl arg definitions
 *
 *	INIT	none
 *	WAIT	timer ticks to wait before timeout
 *	WRITE	gse_io
 *	READ	gse_io
 *	SIGNAL	signal number
 */
/*
 * ioctl arg structure - used by WRITE and READ
 */
struct gse_io
	{
	int v_addr;		/* user virtual address */
	int d_addr;		/* device real adddress */
	int byte_ct;	/* byte count */
	};
