#ifndef __SYS_HLOCK_H__
#define __SYS_HLOCK_H__

/**************************************************************************
 *									  *
 * 		 Copyright (C) 1988, Silicon Graphics, Inc.		  *
 *									  *
 *  These coded instructions, statements, and computer programs  contain  *
 *  unpublished  proprietary  information of Silicon Graphics, Inc., and  *
 *  are protected by Federal copyright law.  They  may  not be disclosed  *
 *  to  third  parties  or copied or duplicated in any form, in whole or  *
 *  in part, without the prior written consent of Silicon Graphics, Inc.  *
 *									  *
 **************************************************************************/

#ident "$Revision: 3.9 $"

/*
 * sys/hardlocks.h -- structures and defines for hardware spinlock allocator
 */

/*
 * Ioctl commands.
 */

/* Allocate lock group. */

#define HL_AMNR	( ('h'<<24) | ('l'<<16) | ('a'<<8) | 'g' )

/* Allocate, deallocate page of locks. */

#define HL_ALCK	( ('h'<<24) | ('l'<<16) | ('a'<<8) | 'l' )
#define HL_DLCK	( ('h'<<24) | ('l'<<16) | ('d'<<8) | 'l' )

/* Return size of lock region */

#define HL_RGSZ	( ('h'<<24) | ('l'<<16) | ('s'<<8) | 'r' )

#ifdef _KERNEL

/*
 * An hlgrp stucture is allocated to each lock group.
 */
typedef struct hlgrp {
	int		hlg_grp;	/* group id	*/
	struct inode	*hlg_ip;	/* inode of minor device */
	struct hlgrp	*hlg_next;	/* next group	*/
	struct hlent	*hlg_ent;	/* entry list	*/
} hlgrp_t;

/*
 * An hlent stucture is allocated for each open of a lock group minor.
 */
typedef struct hlent {
	unsigned	hle_handle;
	reg_t		*hle_reg;
	caddr_t		hle_vaddr;
	struct hlent	*hle_next;
} hlent_t;

extern hlgrp_t 	*hardlockgroups;	/* head of the lock groups list	*/
extern char	hldmap[];		/* bit map of lock pages.	*/
extern sema_t	hllock;			/* lock protecting lock allocs	*/

#endif	/* _KERNEL */
#endif /* __SYS_HLOCK_H__ */
