/* Public definitions for the "Martin Marietta FDDI Single Ring
 *	Interface (SRI)"
 */

#ifndef __IF_MF_H__
#define __IF_MF_H__

#ident "$Revision: 1.7 $"


/* counters for each board
 */
struct mf_counts {
	struct {			/* count the interrupts */
		uint	total;
		uint	dma;
		uint	dpc;
		uint	dpc_nmi;
		uint	rbc_nmi;
		uint	formac;
		uint	formac_nmi;
		uint	frame_errors;
		uint	bad_frames;
		uint	lost_frames;
	} ints;

	struct {			/* count received stuff */
		uint	total;		/* total frames received */
		uint	abort;		/* aborted frames */
		uint	perror;		/* frames with parity errors */
		uint	truncate;	/* early bytes lost */
		uint	error;		/* error detected by local MAC */
		uint	e;		/* received E bit */
		uint	a;		/* received A bit */
		uint	c;		/* received C bit */
		uint	shorterr;	/* packet unreasonably short */
		uint	longerr;	/* packet unreasonably long */
		uint	overruns;	/* receive FIFO overrun */
		uint	strange;	/* unrecognized frames */
	} rcv;

	struct {			/* count MAC events */
		uint	rngop,rngbroke;	/* ring alive or dead */
		uint	multda;		/* multiple destination address */
		uint	misfrm;		/* missed at least one frame */
		uint	xmtabt;		/* transmit abort */
		uint	dpc_xmtabt;	/* transmit abort by the DPC */
		uint	dpc_gap;
		uint	tkerr;		/* duplicate token error */
		uint	clm;		/* claiming */
		uint	bec;		/* beaconing */
		uint	tvxexp;		/* TVX expired */
		uint	trtexp;		/* TRT expired */
		uint	myclm;		/* "my" claim frame received */
		uint	loclm;		/* lower claim frame received */
		uint	hiclm;		/* higher claim frame received */
		uint	mybec;		/* "my" beacon frame received */
		uint	otrbec;		/* strange beacon received */
	} mac;

	struct {
		uint	rbc_snppnd;	/* max waits for RBC_SNPPND */
		uint	rbc_snppnd_err;	/* times when we gave up */
		uint	chains;		/* chains of output */

		uint	dma_act;	/* do not start DMA because active */
	} misc;
};


#endif /* __IF_MF_H__ */
