/**************************************************************************
 *									  *
 * 		 Copyright (C) 1990, Silicon Graphics, Inc.		  *
 *									  *
 *  These coded instructions, statements, and computer programs  contain  *
 *  unpublished  proprietary  information of Silicon Graphics, Inc., and  *
 *  are protected by Federal copyright law.  They  may  not be disclosed  *
 *  to  third  parties  or copied or duplicated in any form, in whole or  *
 *  in part, without the prior written consent of Silicon Graphics, Inc.  *
 *									  *
 **************************************************************************/

#ifndef __SYS_KMEM_H__
#define __SYS_KMEM_H__
#ident	"$Revision: 1.2 $"

/*
 * Definitions for kmem_*, must match VM_*
 */
#define KM_SLEEP	0
#define KM_NOSLEEP	1	/* must match VM_NOSLEEP */
#define KM_PHYSCONTIG	0x0100	/* physically contiguous */
#define KM_CACHEALIGN	0x0400	/* guarantee that memory is cache aligned */

/*
 * Function prototypes.
 */

extern	void	*kmem_alloc(size_t, int);
extern	void	*kmem_zalloc(size_t, int);
extern	void	*kmem_realloc(void *, size_t, int);
extern	void	kmem_free(void *, size_t);

#endif /* __SYS_KMEM_H__ */
