
/**************************************************************************
 *									  *
 * 		 Copyright (C) 1989, Silicon Graphics, Inc.		  *
 *									  *
 *  These coded instructions, statements, and computer programs  contain  *
 *  unpublished  proprietary  information of Silicon Graphics, Inc., and  *
 *  are protected by Federal copyright law.  They  may  not be disclosed  *
 *  to  third  parties  or copied or duplicated in any form, in whole or  *
 *  in part, without the prior written consent of Silicon Graphics, Inc.  *
 *									  *
 **************************************************************************/

#ident "$Revision: 1.3 $"

/* logical volume label structures. */
/* Author: Dave Higgen (daveh) @ SGI */

/*  For every partition on a disk which is part of a logical volume, there
 *  must be a corresponding logical_volume_label file in the label partition.
 *  Struct lvlabel defines the format of such files. They are named
 *  in accordance with the relevent partition name: eg if partition 0
 *  is a logical volume component, there is a corresponding file "lvlab0"
 *  accessible via the directory in the label partition. 
 *  Note: MAXVNAMELEN is defined in lvtab.h; both that file and this
 *  are automatically included by lv.h.
 */


struct lvlabel	{
	unsigned  lvmagic;		/* identifying magic # */
	dev_t	  mydev;		/* Device which the partition
					   believes itself to be.
					   For consistency checking: physical
					   disks can move!! */
	char	  volname[MAXVNAMELEN];	/* Human-assigned name */
	char	  volid[MAXVNAMELEN];	/* System-assigned name */
	struct lv lvdescrip;		/* replicated complete description of
					   the volume to which this partition
					   belongs */
	};

#define LV_MAGIC 0xfabace	/* Fab! Ace! */

