/* ioctl */
#define	INITIOC		('i'<<8)
#define	DOWNLOAD	(INITIOC|0x1)	/* download the microcode */
#define	RESET_8344	(INITIOC|0x2)	/* reset the 8344 */

#define	CUTIOC		('c'<<8)	/* cut mode IOC */
#define EM_CTRL		(CUTIOC|0x1)	/* emulation control */
#define	SET_DID		(CUTIOC|0x2)	/* set device id */
#define	START_COMM	(CUTIOC|0x3)	/* start communicating with the cu */
#define	STOP_COMM	(CUTIOC|0x4)	/* stop communicating with the cu */
#define	CUR_UD		(CUTIOC|0x5)	/* cursor update */
#define	SCR_UD		(CUTIOC|0x6)	/* screen update */
#define SEND_KEY	(CUTIOC|0x7)	/* send scan code */
#define STAT_UD		(CUTIOC|0x8)	/* send scan code */
#define BEGIN_MSG	(CUTIOC|0x11)	/* begin messaging mode */
#define	END_MSG		(CUTIOC|0x12)	/* end messaging mode */
#define	SEND_MSG	(CUTIOC|0x13)	/* send message */
#define	RECV_MSG	(CUTIOC|0x14)	/* receive message */
#define	SET_TIME	(CUTIOC|0x15)	/* set timeout value for receiving msg */
#define	SEND_IND	(CUTIOC|0x16)	/* send IND$FILE data */
#define SELF_TST	(CUTIOC|0x21)	/* 8344 self test */
#define	REG_TST		(CUTIOC|0x22)	/* register test */
#define DP_MEM_TST	(CUTIOC|0x23)	/* dual port memory test */
#define IT_MEM_TST	(CUTIOC|0x24)	/* instruction memory test */
#define	INTR_TST	(CUTIOC|0x25)	/* interrupt test */
#define CLR_DBUF	(CUTIOC|0x31)	/* clear on-board d_buf and kernel d_buf */
#define	CLR_MBUF	(CUTIOC|0x32)	/* clear m_buf on the board */
#define	DUMP_COMM	(CUTIOC|0x33)	/* dump the communication area */
#define	DUMP_DBUF	(CUTIOC|0x34)	/* dump the d_buf on the board */
#define	DUMP_MBUF	(CUTIOC|0x35)	/* dump the m_buf on the board */
#define	DUMP_K_MBUF	(CUTIOC|0x36)	/* dump the m_buf in the kernel */

#define	DRVTRACEIOC	('t'<<8)
#define	INIT_TRACE_BUF	(DRVTRACEIOC|0x1)
#define	CLR_TRACE_BUF	(DRVTRACEIOC|0x2)
#define	VERSION			(DRVTRACEIOC|0x3)	/* print out microcode version */

/* misc (CUT mode) */
#define	LN_STATUS	80
#define	SZ_DSP_BUF	4096	/* size of display buffer */
#define	SZ_DSP_BUF_INT	1024	/* size of display buffer in long word */
#define	SZ_MSG_BUF	65536	/* size of message buffer */
#define	SZ_MSG_BUF_INT	16384	/* size of message buffer in long word */
#define	SZ_MAP_BUF	(SZ_DSP_BUF+SZ_MSG_BUF+SZ_DSP_BUF)
#define	MAX_ROWS	44		/* model 4 */

#define RESET_PC *card->ric_reg = PCLOW_ACC; \
		 *card->base = 0; \
		 *card->ric_reg = PCHI_ACC; \
		 *card->base = 0

#define	DFTIOC		('d'<<8)	/* dft mode IOC */
#define	GET_DFTRDSZ	(DFTIOC|0x1)

/* misc (DFT mode) */
#define	SZ_DRV_TRACE_BUF	65536	/* size of driver trace buffer: 64k */




#ifdef	_KERNEL
/* offset of register/control/data area on the board */
#define	O_RIC_REG	0x20000
#define O_CTRL_REG	0x60000
#define O_STAT_REG	0x70000
#define O_VEC_REG	0x70000
#define O_COMM_AREA	0x7e00
#define O_DSP_BUF	0x0
#define O_EAB_BUF	0x1000
#define O_MSG_BUF	0x10000
#define O_TCA		0x0

/* command/flag used to set/check the register/control area on the board */
/* 8344 - ric register */
#define	STOP_8344	0x20	/* stop 8344 */
#define	INSMEM_ACC	0x21	/* select 8344 instruction memory access */
#define	PCLOW_ACC	0x22	/* select 8344 PC low byte access */
#define	PCHI_ACC	0x23	/* select 8344 PC high byte access */
#define	START_8344	0x24	/* start 8344 */

/* 3270 card - control register */
#define	RIC_PC_IM_ACC	0xa0	/* allow access to ric register, 8344 PC
					and instruction memory */
#define	DPMEM_ACC	0xa4	/* allow access to dual-port memory */
#define	INT_ENABLE	0x01	/* interrupt enable */

/* communication area - control flag */
#define DFT_MODE	0x80
#define RXID_ENABLE	0x4

/* communication area - hcr */
#define	UPDATE		0x1
#define	KEY			0x2
#define	START		0x3	/* start communicating with the host */
#define	STOP		0x5	/* stop communicating with the host */
#define	SYNC_STS	0x6	/* synchronous status available */
#define	ASYNC_STS	0x8	/* asynchronous status available */
#define	EXP_STS		0x7	/* expedited ststus available */
#define	START_MSG	0xa	/* start messaging mode */
#define	STOP_MSG	0xb	/* stop messaging mode */
#define	CLR_LNCH	0xc	/* clear line change with mask */
#define	TEST		0xf

/* communication area - ists */
#define	PO_RESET	0x1	/* power on reset received from the cu */
#define DIAG_RESET	0x2	/* diagnostic reset received from the cu */
#define	START_OP	0x3	/* start operation cmd received from the cu */
#define	ALT_START_OP	0x4	/* alternate start op cmd received from the cu*/

/* communication area - tsr */
#define	TEST_ALL	0x7

/* defines for the flag field of the per card info */
/* common to CUT & DFT */
#define INIT3270	0x1		/* done with edtinit */
#define	DLOAD		0x2		/* done with download */
#define OPEN3270	0x4		/* done with open */
#define	DFT_FLAG	0x8
/* CUT mode */
#define	LNCH_ENABL	0x100	/* line change enabled */
#define	EAB_ENABL	0x200	/* extended attribute enabled */
/* DFT mode */
#define	DBTI_START	0x100	/* start of a .5 sec Device Busy Timing interval */
#define	DBTI_SENT	0x200	/* an expedited status request DBTI was sent to
					the CU at the end of the .5 sec */
#define	RDAT_PENDING	0x400
#define	LNK_TRC		0x800	/* link level trace flag */
#define FCIR_PENDING	0x1000
#define AEEP_PENDING	0x2000

/* defines for the flag field of the per session info */
#define	DRR_RU		0x1	/* Definite Response Required RU */

/* TCA map */
#define	DPASTAT		0x0	/* asynchronous status present flag */
#define	DPSSTAT		0x1	/* synchronous status present flag */
#define	DSSV		0x2	/* synchronous status value */
#define	DSSP		0x3	/* synchronous status parameter 1 */
#define	DSSP2		0x4	/* synchronous status parameter 2 */
#define	DSSP3		0x5	/* synchronous status parameter 3 */
#define	DALTAD		0x6	/* logical terminal address */
#define	DAEV		0x7	/* asynchronous status event value */
#define	DAEP		0x8	/* asynchronous status event parameter 1 */
#define	DAEP2		0x9	/* asynchronous status event parameter 2 */
#define	DAEP3		0xa	/* asynchronous status event parameter 3 */
#define	DAEP4		0xb	/* asynchronous status event parameter 4 */
#define	DTID1		0xc	/* terminal id */
#define	DTID2		0xd	/* product id */
#define	DBUF1		0x10	/* device buffer size in bytes */
#define	DBUF2		0x11	/* device buffer size in bytes */
#define	EXFLT		0x20	/* LT address */
#define	EXFRQ		0x21	/* expedited status value */
#define EXFP1		0x22	/* expedited status parameter 1 */
#define EXFP2		0x23	/* expedited status parameter 2 */
#define EXFP3		0x24	/* expedited status parameter 3 */
#define EXFP4		0x25	/* expedited status parameter 4 */
#define	EXFAK		0x26	/* post/acknowledgement flag byte */
#define	CUDP1		0x40	/* data address within the device buffer */
#define	CUDP2		0x41	/* data address within the device buffer */
#define	CULTAD		0x42	/* logical terminal address */
#define	CUFRV		0x44	/* synchronous function request value */
#define	CUSYN		0x45	/* request synchronization switch */
#define	CUFRP1		0x46	/* synchronous function request parameter 1 */
#define	CUFRP2		0x47	/* synchronous function request parameter 2 */
#define	CUFRP3		0x48	/* synchronous function request parameter 3 */
#define	CUFRP4		0x49	/* synchronous function request parameter 4 */
#define CUDPORT		0x50	/* device port number */
#define	CUAT		0x51	/* control unit host attachment protocol */
#define	CUDSER1		0x52	/* error code value for last-ditch-cmd-queue */
#define	CUDSER2		0x53	/* error code value for last-ditch-cmd-queue */
#define	CULTA1		0x54	/* LT address */
#define	CULTA2		0x55	/* LT address */
#define	CULTA3		0x56	/* LT address */
#define	CULTA4		0x57	/* LT address */
#define	CULTA5		0x58	/* LT address */
#define EXFD1		0x5c	/* expedited status response parameter 1 */
#define EXFD2		0x5d	/* expedited status response parameter 2 */
#define EXFD3		0x5e	/* expedited status response parameter 3 */
#define EXFD4		0x5f	/* expedited status response parameter 4 */
#define EXTIME		0x60	/* host transaction timing */
#define	CUDSL		0x61	/* DSL type */
#define	CUSLVL1		0X7e	/* controll TCA support level */
#define	CUSLVL2		0X7f	/* controll TCA support level */
#define	CUDATA		0x80	/* data area */
#define	TCA_SZ		0x80

/* dssv - synchronous status value */
#define	FC		0x4	/* function complete */
#define	FCIR		0x6	/* function complete with input required */
/* cufrv - synchronous function request value */
#define	WCUS		0x2	/* write control unit status */
#define	WDAT		0x3	/* write data function request */
#define	RDAT		0x8
#define	PDAT		0xa
/* daev - asynchronous status event */
#define	AEDV		0x28	/* to request that lt be put online or taken
					offline */
#define	AEEP		0x22	/* inbound event pending */
/* exfrq - expedited status value */
#define	DBTI		0x2	/* device busy timing interval */

/* macros to get/put a certain field in the TCA */
#define	GETTCA(tca,field_offset,p) { \
	volatile u_int *ip = tca; \
	volatile unchar *c = (unchar*)p; \
	ip += (field_offset/4); \
	switch (field_offset%4) { \
	case 0: \
		*c = (*ip >> 24); \
		break; \
	case 1: \
		*c = (*ip >> 16); \
		break; \
	case 2: \
		*c = (*ip >> 8); \
		break; \
	case 3: \
		*c = *ip; \
		break; \
	} \
}
#define	PUTTCA(tca,field_offset,val) { \
	u_int *ip = tca; \
	ip += (field_offset/4); \
	switch (field_offset%4) { \
	case 0: \
		*ip = (*ip & 0xffffff) | (val << 24); \
		break; \
	case 1: \
		*ip = (*ip & 0xff00ffff) | (val << 16); \
		break; \
	case 2: \
		*ip = (*ip & 0xffff00ff) | (val << 8); \
		break; \
	case 3: \
		*ip = (*ip & 0xffffff00) | val; \
		break; \
	} \
}

/* list related operation */
#define	EMPTY(hdr)	(((hdr)->fp == (dbuf_t*)(hdr)) ? 1 : 0)
						/* empty list? */
/*
 *  'APPEND' appends the buffer 'db' to the list pointed to by 'hdr'
 *  and then signal the s2_schd if necessary.
 */
#define	APPEND(hdr, db, sig) { \
		short	signal_flag = 0; \
		if (EMPTY(hdr))  /* empty list */ \
			signal_flag = 1; \
		append(hdr, db); \
		if (nodep->nodasync==TRUE && signal_flag) { \
			nodep->nodasync = FALSE; \
			psignal(nodep->nodproc, sig); \
		} \
}

/* buffer related defines */
#define	HOST_MAX_DATA	4096	/* max data segment size (multiple of 256)
									the IBM host can send */
#define	MAX_BUF			(4096-8)	/* max driver buffer size (4k less 8 bytes
										for forward & backward pointer) */
#define	DRV_MAX_DATA	(MAX_BUF-9)	/* max data segment size the driver
										supports (MAX_BUF less 6 bytes for TH
										and 3 bytes for RH) */
#define	N_BUF		25	/* number of transmit/receive buffers */

/* misc (CUT + DFT mode) */
#define	DFT_DEV		0x80
#define	C2I(c)		((c)>='A' ? (c)-'A'+10 : (c)-'0')  /* hex char to int */

#define	EQUAL		1
#define	NEQUAL		2
#define	BYTE_ACC	1
#define	WORD_ACC	2
#define	T3270PRI	(PZERO+1)

/* misc (CUT mode) */
#define	ROW2OFFSET(r)	((r==0) ? 0 : (LN_STATUS+(r-1)*card->cols))

#define ALT_MAKE	0x4f	/* scan code for ALT MAKE */
#define ALT_BREAK	0xcf	/* scan code for ALT BREAK */
#define	KEY_EEOF	0x55	/* scan code for erase-end-of-field */
#define	KEY_ENTER	0x18	/* scan code for enter */
#define KEY_HOME	0x35	/* scan code for the HOME key */
#define KEY_RESET	0x34	/* scan code for the RESET key */
#define SHIFT_BREAK	0xcd	/* scan code for SHIFT BREAK */

#define	HCR			1
#define	KSC			2

/* misc (DFT mode) */
#ifdef DTRACE
#define	MTRC(A)		if (trace_flag) msg_trc A
#define	SMTRC(A)	if (trace_flag) sm_trc A
#define	BMTRC(A)	if (trace_flag) bm_trc A
#else
#define	MTRC(A)
#define	SMTRC(A)
#define BMTRC(A)
#endif

#ifndef TRUE
#define	TRUE		1
#define	FALSE		0
#endif
#define	N_SESSIONS	5		/* number of sessions supported by each coax card */
#define	TH_SZ		6		/* size of the Transmit Header */
#define MAX_SERVERS	16		/* # of s2_schd allowed to run at one time */
#define MASTER_DEV	0x90	/* minor number of the master device */
#define	LNK_TRC_DEV 0xa0	/* minor number of the link trace device */
#define	DRV_TRC_DEV 0xc0	/* minor number of the driver trace device */

				


/* the following are copied from the si include files */
#define	XIDSIZ		29
#define	THSTART		10	/* offset of the Transmit Header */

#define S2IOC	    ('S'<<8)
#define ASYNCON	    (S2IOC|1)
#define ASYNCOFF    (S2IOC|2)
#define CONFIGLS    (S2IOC|3)
#define CONFIGALS   (S2IOC|4)
#define	GETERR	    (S2IOC|8)
#define ORECMD	    (S2IOC|9)

/* DLC internal signals */
#define	CONTACT		0x01
#define	ACTLINK		0x0a
#define	CONTACTD	0x80
#define	INOP		0x81
#define	XIDSIG		0xb6

#define	ORE_XID		0xf2	/* ore is an XID */
#define	ORE_INOP	0xf3	/* ore is an INOP */
#define	ORE_CNTD	0xf4	/* ore is an CONTACTD */

#define	NO_DSR		0xf8	/* 'DSR dropped' */

#define	LOADED		0x01

/* the following are for the link trace ioctl */
#define	TRACEON		10
#define	TRACEOFF	20
#define	TRACEMOD	30
#define	TRACERD		40

#define	ITRC_RD		0x01
#define	ITRC_WR		0x02

#define	SDLCNTL		2		/* SDLC address + SDLC control bytes */
#define	I_FRAME		0x0

#define	IT_NODATA	4
#define	IT_FAULT	5

#define	POSITIVE	0
#define	NEGATIVE	1

typedef struct	{	/* passed as argument with the CONFIGLS ioctl call */
	u_short	ls_ea;
	u_short	ls_type;	/* link type always SDLC */
	u_short	ls_conn;	/* conn type leased or switched */
	u_short ls_role;	/* primary or secondary */
	u_short	ls_maxbtu;	/* max btu size we can receive */
	u_short	ls_speed;	/* baud rate */
	u_short	ls_maxabort;	/* max times we will resend a frame because it
					aborted */
	u_short	ls_nrzi;	/* specify data encoding: 0 = NRZ, 1 = NRZI */
	u_short	ls_maxi;	/* max i frames we will receive on this link */
	u_short	ls_hdx;	/* half duplex flag =0 NO, =1 YES */
	/* new parameters for Rel 3.2 */
	u_short	ls_dial;	/* dialer: manual = 0, SADL = 1, V.25bis = 2 */
	/* These last 2 will only work on some hardware implementation */
	u_short	ls_txclk;	/* external = 0, internal = 1 */
	u_short	ls_rxclk;	/* external = 0, internal = 1 (NRZI only) */
}	ddslscv_t;

typedef	struct	{	/* passed as arg with the CONFIGALS ioctl() call */
	u_short	als_ea;
	u_short	als_addr;	/* sdlc link address */
	u_int	als_idlet;	/* idle time in milliseconds */
	u_int	als_nprodt;	/* nonproductive receive time in milliseconds */
	u_short	als_retry;	/* max retry count */
	u_short	als_maxbtu;	/* max btu size we will send */
	u_short	als_maxiframe;	/* max # i-frames we will send w/o response */
	u_char	als_xid[XIDSIZ];
	/* New parameters for Rel 3.2 */
	u_short	rmaxbtu;	/* max btu size we will receive from station */
	u_short	rmaxifr;	/* max i-frames we will receive from station */
	u_short	rclock;	/* Receive Clocking */
	u_short	tclock;	/* Transmit Clocking */
}	ddsalcv_t;

/* this struct is not used and struct list_hdr_t is used for noderr and nodrcvq
   instead

typedef	struct	{
	u_char	*fp;
	u_char	*bp;
	u_int	freelist;
	u_short	head;
	u_short	bid;
}	klist_t;

*/

typedef	struct	{
	int	sig_in;	/* signal to use for input available */
	int	sig_out;	/* signal to use for output flow control */
	int	sig_ore;	/* signal to use for ore available */
}	ddssig_t;

typedef struct	{	/* ORE control block */
	u_int	mu_corl;
	u_short	ea;	/* element address of ajcb or lkcb */
	u_short	d_size;	/* size of data field which follows */
	u_short	chksnse;	/* if negative Response, check sense */
	u_short	chkex;
	u_char	type;	/* ORE constant */
	u_char	oreval;	/* SIGNAL or MU Value */
	u_char	rsp_ind;	/* POS=positive response, else NEG */
	u_char	linkid;
}	ddsore_t;

typedef	struct	{	/* BTU control block */
	u_short	ea;	/* element address of AJCB */
	u_char	linkid;	/* si tag byte */
	u_char	ldi;	/* lost data indicator */
	u_short	lbtu;	/* length of btu */
#ifdef SEGMENT
	ushort	off;
	ushort	fill;
#else
	u_char	fill[4];	/* reserved for SDLC station address */
#endif
}	ddsbtu_t;	/* NOTE: if this struct is modified, 'THSTART' needs
				 to be redefined */

struct	ddsitctl {
	unchar	cmask;
	unchar	cdata;
	unchar	fmask;
	unchar	fdata;
};

typedef struct	{
	short	cmd;
	short	retval;
	short	dev;
	short	bsize;
	struct	ddsitctl	ctl;
	char	*baddr;
}	ddsitcmd_t;

typedef struct	{	/* BLU control block    */
		ushort	lblu;		/* Length of BLU        */
		ushort	ldi;		/* Lost Data Indicator  */
		unchar	fill[4];	/* 4 bytes so sdlc_adr is at right offset */
		unchar	sdlc_adr;	/* SDLC Station Address */
		unchar	p_cont;		/* SDLC Control Byte */
}	ddsblu_t;

typedef	struct	{
	long	timestamp;
	short	length;
	short	link;
	short	flags;
	short	fill1;
}	ddstrec_t;

typedef	struct	{	/* I Frame Structure	*/
	unchar	sdlc_adr;		/* Reserved				*/
	unchar	nr		: 3;	/* Receive Count	*/
	unchar	poll_fin: 1;	/* Poll/Final Indicator */
							/* 1 = POLL/FINAL */
							/* 0 = no, 1 = yes	*/
	unchar	ns		: 3;	/* Send Count */
	unchar	type	: 1;	/* SDLC Command Type */
							/* 0 = I_FRAME */
}	ddsi_fr_t;

/* end of si */

typedef	struct	{	/* communication area */
	u_int	:24;
	u_char	hcr;
	u_int	:16;
	u_short	creg;
	u_int	:16;
	u_short	ac;
	u_int	:16;
	u_short	next;
	u_int	:24;
	u_char	flg;
	u_int	:24;
	u_char	onl;
	u_int	:16;
	u_short	id;
	u_int	rxid;
	u_int	:24;
	u_char	ksc;
	u_int	:24;
	u_char	actv;
	u_int	:24;
	u_char	ists;
	u_int	:24;
	u_char	tsr;
	u_int	:16;
	u_short	var;
	u_int	:24;
	u_char	bell;
	u_int	:24;
	u_char	ert;
	u_int	:16;
	u_short	er;
	u_int	lnchhi;
	u_int	lnchlo;
	u_int	mkchhi;
	u_int	mkchlo;
} comm_area_t;

typedef struct {
	u_int	pattn_w;
	u_int	pattn_r;
	u_short	err_addr;
	u_char	err_flag;
	u_char	cycles;
}	di_info_t;  /* diag info */

typedef	struct	dbuf	{
	struct	dbuf	*fp;	/* forward pointer */
	struct	dbuf	*bp;	/* backward pointer */
#define	BUF_DATA_OFFSET	8	/* offset of 'data' in struct dbuf */
	unchar	data[MAX_BUF];
}	dbuf_t;

typedef	struct	{	/* list header */
	dbuf_t	*fp;	/* pointer to the beginning of the list */
	dbuf_t	*bp;	/* pointer to the end of the list */
} list_hdr_t;

typedef	struct	{
	u_char	lt;
	u_char	flag;
}	lt_flag_t;

/* the following are copied from the si include files */ 
typedef	struct	{
	struct	proc	*nodproc;
	int	nodpid;
	list_hdr_t	noderr;
	list_hdr_t	nodrcvq;
	ddssig_t	nod_sigs;
	short	nodcnt;
	u_char	nodasync;
	u_char	sigout_pending;	/* sig_out is pending */
	u_char	nodtxblock;	/* node hit an ENOPSC error */
}	ddsnode_t;
/* end of si */

typedef struct  {	/* card info */
	/* common to CUT & DFT */
	u_int	*base;	/* base addr */
	u_int	*ric_reg;
	u_int	*ctrl_reg;
	u_int	*stat_reg;
	u_int	*vec_reg;
	comm_area_t *ca;

	/* CUT mode */
	u_char	*dsp_buf;
	u_char	*eab_buf;
	u_char	*msg_buf;
	u_char	*k_dsp_buf;
	u_char	*k_eab_buf;
	u_char	*k_msg_buf;
	u_int	mb_head;
	u_int	mb_tail;
	int		recv_timeout;
	int		send_timeout;
	int		key_timeout;
	int		rows;
	int		cols;

	/* DFT mode */
	u_int	*tca;
	ddsnode_t	*nodep;
	list_hdr_t	rxfreel;	/* list of free receive buffer */
	list_hdr_t	txfreel;	/* list of free transmit buffer */
	list_hdr_t	btusend;
	list_hdr_t	trfreel;	/* link-trace free buffer list */
	list_hdr_t	tr_q;		/* link-trace buffer queue */
	caddr_t	rx_buf_pool;
	caddr_t	tx_buf_pool;
	caddr_t	tr_buf_pool;	/* link-trace buffer pool */
	ddslscv_t	lscv;	/* link station control */
	ddsalcv_t	alcv;	/* adjacent link stattion control */
	caddr_t	request;	/* ore request from the SNA */
	int	timeid;	/* timeout id */
	lt_flag_t	lt_flag[N_SESSIONS];
	caddr_t	trace_buf;
	caddr_t	tbp;
	uint	*template;
	uint	*template_intr;  /* template used by the interrupt routine only */
	ushort	numseg, segsz;

	/* common to CUT & DFT */
	u_short	flag;
	u_char	irl;	/* interrupt request level */
	u_char	iv;	/* interrupt vector */
} t3270_card_t;
#endif	/* _KERNEL */

#ifndef VM_STALE
#define VM_STALE	0
#endif
