#ifndef __XUMTP_H__
#define __XUMTP_H__
#ifdef __cplusplus
extern "C" {
#endif
/**************************************************************************
 *									  *
 * 		 Copyright (C) 1989, Silicon Graphics, Inc.		  *
 *									  *
 *  These coded instructions, statements, and computer programs  contain  *
 *  unpublished  proprietary  information of Silicon Graphics, Inc., and  *
 *  are protected by Federal copyright law.  They  may  not be disclosed  *
 *  to  third  parties  or copied or duplicated in any form, in whole or  *
 *  in part, without the prior written consent of Silicon Graphics, Inc.  *
 *									  *
 **************************************************************************
 *
 * $Revision: 1.3 $
 *
 * Declarations of unsupported routines to access extended utmp/wtmp files.
 * For use by SGI only: these routines and the extended files will not be
 * in the next major release of IRIX -- DO NOT use them.
 */

#include <utmp.h>

#define _XUTMP_FILE	"/etc/xutmp"
#define _XWTMP_FILE	"/etc/xwtmp"

struct xutmp {
	struct utmp utx_utmp;
	char utx_host[64];	/* user@host or host */
};
#define utx_user	utx_utmp.ut_user
#define utx_name	utx_utmp.ut_name
#define utx_id		utx_utmp.ut_id
#define utx_line	utx_utmp.ut_line
#define utx_pid		utx_utmp.ut_pid
#define utx_type	utx_utmp.ut_type
#define utx_exit	utx_utmp.ut_exit
#define utx_time	utx_utmp.ut_time

extern struct xutmp *	_xgetutent(void);
extern struct xutmp *	_xgetutid(struct xutmp *);
extern struct xutmp *	_xgetutline(struct xutmp *);
extern struct xutmp *	_xpututline(struct xutmp *);
extern void		_xutmpname(char *);
extern void		_xsetutent(void);
extern void		_xendutent(void);
extern void		_xutupdate(struct utmp *, char *, char *, int, int *);

#ifdef __cplusplus
}
#endif
#endif /* !__XUMTP_H__ */
